#!/usr/bin/perl -w
#
# MicroPlan2002Qxɥ󥿥ץ꥿
#
# (c) FukTommy<fuktommy@my.tramonline.net>
#
# 2002/05/18	ver.-.-.-	ΰβ
# 2002/05/19	ver.-.-.-	ѿλȤ`&'ѹ
# 2002/05/20	ver.-.-.-	ȤĤ褦
# 2002/05/21	ver.-.-.-	顼åSTDERR˽
# 2002/05/25	ver.-.-.-	put̿˽Ϥؤ
# 2002/05/26	ver.0.0.1	nop,puti,putiln̿ɲ
# 2002/05/26	ver.0.0.2	Ƥʤѿ0Ȥƽ
# 2002/05/27	ver.0.0.3	;黻ҤդäΤ
#

# ѿ
@input	= ();	# 
@code	= ();	# ΰ
@global	= ();	# ǡΰ
@stack	= ();	# å
$pc	= 0;	# ץ५
$local	= 0;	# ١

# ν
if (grep $_ eq "--help", @ARGV) {
	exec "cat $0";
} elsif (@ARGV == 0) {
	@input = <STDIN>;
} elsif (@ARGV == 1) {
	open IN, $ARGV[0];
	@input = <IN>;
	close IN;
} else {
	die "usage: $0 [Qx-code-file]\n";
}

# ΰѰդʤ
for ($i=0; $i<@input; $i++) {
	$_ = $input[$i];
	s/^\s+//;
	if (/^$/ || /^#/) {		# ԡȹ
		next;
	} elsif (/^(\d+):\s*/) {	# ̿
		$code[$1] = $';
	} else {			# ʸˡ顼
		printf STDERR "Syntax error at line %d.\n", $i+1;
		print STDERR;
		exit 1;
	}
}

# ȼ¹
push @stack, 0;
while ($pc < @code) {
	$pc = inter($pc);
}

#--------------------------------------------------------------------------#
# Ԥβ¹
# : ᤹ԤΥץ५
# : Υץ५
sub inter {
	my   $pc = $_[0];
	local $_ = $code[$pc];
	local @_ = split;

	if ($_[0] eq "nop") {			# ⤷ʤ
		# do nothing;

	} elsif ($_[0] eq "ps") {		# ץå
		my $op = operand($_[1], $pc);
		push @stack, $op;

	} elsif ($_[0] eq "psm") {		# λ
		my $op = operand($_[1], $pc);
		$stack[-1] = $global[$op + $stack[-1]];

	} elsif ($_[0] eq "plm") {		# ؤ
		my $op = operand($_[1], $pc);
		my $x  = pop @stack;
		my $z  = pop @stack;
		$global[$op+$z] = $x;

	} elsif ($_[0] eq "eq") {		# 
		my $op = operand($_[1], $pc);
		my $x  = pop @stack;
		if ($op == $x) {
			push @stack, ~0;
		} else {
			push @stack, 0;
		}

	} elsif ($_[0] eq "ne") {		# (:)
		my $op = operand($_[1], $pc);
		my $x  = pop @stack;
		if ($op != $x) {
			push @stack, ~0;
		} else {
			push @stack, 0;
		}

	} elsif ($_[0] eq "lt") {		# (<)
                my $op = operand($_[1], $pc);
                my $x  = pop @stack;
		if ($op > $x) {
			push @stack, ~0;
		} else {
			push @stack, 0;
		}

	} elsif ($_[0] eq "gt") {		# (>)
		my $op = operand($_[1], $pc);
		my $x  = pop @stack;
		if ($op < $x) {
			push @stack, ~0;
		} else {
			push @stack, 0;
	}

	} elsif ($_[0] eq "add") {		# û
		my $op = operand($_[1], $pc);
		$stack[-1] += $op;

	} elsif ($_[0] eq "sub") {		# 
		my $op = operand($_[1], $pc);
		#$stack[-1] = $op - $stack[-1];
		$stack[-1] -= $op;

	} elsif ($_[0] eq "or") {		# 
		my $op = int operand($_[1], $pc);
		my $st = int $stack[-1];
		$stack[-1] = $op | $st;

	} elsif ($_[0] eq "mul") {		# 軻
		my $op = operand($_[1], $pc);
		$stack[-1] *= $op;

	} elsif ($_[0] eq "div") {		# 
		my $op = operand($_[1], $pc);
		$stack[-1] = int($stack[-1] / $op);

	} elsif ($_[0] eq "mod") {		# ;
		my $op = operand($_[1], $pc);
		$stack[-1] %= $op;

	} elsif ($_[0] eq "and") {		# 
		my $op = int operand($_[1], $pc);
		my $st = int $stack[-1];
		$stack[-1] = $op & $st;

	} elsif ($_[0] eq "call") {		# ؿ³ƽФ
		my $addr = operand($_[1], $pc);
		my ($null, $argsize, $localsize) = split /\s+/, $code[$addr];
		@stack = (@stack[0..$#stack-$argsize], $pc+1, $local,
					@stack[1+$#stack-$argsize..$#stack]);
		$local = $#stack-$argsize;
		my $i=$argsize;
		push(@stack, 0) while($i++ < $localsize);
		return $addr+1;
		
	} elsif ($_[0] eq "jp") {		# ̵兩
		my $addr = operand($_[1], $pc);
		return $addr;

	} elsif ($_[0] eq "jf") {		# ʬ
		my $addr = operand($_[1], $pc);
		my $x = pop @stack;
		return $addr if ($x == 0);

	} elsif ($_[0] eq "pl") {		# ǡǼ
		my $addr = operand($_[1], $pc);
		my $x = pop @stack;
		$$addr = $x;

	} elsif ($_[0] eq "inc") {		# 󥯥
		my $addr = operand($_[1], $pc);
		push @stack, ++$$addr;

	} elsif ($_[0] eq "dec") {		# ǥ
		my $addr = operand($_[1], $pc);
		push @stack, --$$addr;

	} elsif ($_[0] eq "retp") {		# ³
		$pc = $stack[$local-1];
		my $old = $stack[$local];
		pop @stack until (@stack == $local-1);
		$local = $old;
		return $pc;

	} elsif ($_[0] eq "retf") {		# ؿ
		my $x = pop @stack;
		$pc = $stack[$local-1];
		my $old = $stack[$local];
		pop @stack until (@stack == $local-1);
		$local = $old;
		push @stack, $x;
		return $pc;

	} elsif ($_[0] eq "get") {		# get̿
		my $c = getc;
		if (defined $c) {
			push @stack, unpack("C", $c);
		} else {
			push @stack, 255;
		}

	} elsif ($_[0] eq "halt") {		# halt̿
		exit;

	} elsif ($_[0] eq "put") {		# put̿
		local $_ = pop @stack;
		if ($_ == 1) {
			select STDOUT;
		} elsif ($_ == 2) {
			select STDERR;
		} else {
			$_ &= 0x00FF;
			$_ = pack "C", $_;
			print;
		}

	} elsif ($_[0] eq "puti") {		# puti̿
		print pop @stack;

	} elsif ($_[0] eq "putiln") {		# putiln̿
		print pop @stack;
		print "\n";

	} elsif ($_[0] eq "not") {		# not ̿
		$stack[-1] = ~int($stack[-1]);

	} elsif ($_[0] eq "puts") {		# puts̿
		s/$_[0]\t*//;
		s/\n//;
		print;

	} else {
		printf "\nSyntax error at code %d.\n", $pc;
		print;
		exit 1;
	}
	return $pc+1;
}

#--------------------------------------------------------------------------#
# ڥɤ
# : ڥɤʸ, ץ५
# : ڥɤ
sub operand {
	local $_ = $_[0];
	my $pc = $_[1];
	$_ = "" unless (defined $_);
	if (/^pop$/) {				# åΥݥå
		return pop @stack;
	} elsif (/^[+-]?\d+$/) {		# 
		return $&;
	} elsif (/^g\[(\d+)]$/) {		# ǡΰ
		$global[$1] = 0 unless (defined $global[$1]);
		return $global[$1];
	} elsif (/^l\[(\d+)]$/) {		# ɽǡΰ
		$stack[$local+$1] = 0 unless (defined $stack[$local+$1]);
		return $stack[$local+$1];
	} elsif (/^&g\[(\d+)]$/) {		# ǡΰΥɥ쥹
		$global[$1] = 0 unless (defined $global[$1]);
		return \$global[$1];
	} elsif (/^&l\[(\d+)]$/) {		# ɽǡΰΥɥ쥹
		$stack[$local+$1] = 0 unless (defined $stack[$local+$1]);
		return \$stack[$local+$1];
	} else {
		printf "\nSyntax error at code %d.\n", $pc;
		print $code[$pc];
		exit 1;
	}
}
